﻿''' <summary>
''' Author: Oliver Schirm
''' Date: 16.10.2015
''' Description: Paints a binary representation into a bitmap.
''' </summary>
Public Class TilePainter
    ''' <summary>
    ''' Creates a bitmap with all tiles. Fills marked tiles with black color.
    ''' </summary>
    Public Shared Function writeRepresentationToBitmap(ByRef bRepr As Boolean(,), ByVal iTileWidth As Integer, ByVal iTileHeight As Integer) As Bitmap
        Dim bmp As New Bitmap((bRepr.GetUpperBound(0) + 1) * iTileWidth, (bRepr.GetUpperBound(1) + 1) * iTileHeight)
        Dim iTileX As Integer = 0
        Dim iTileY As Integer = 0
        For iTileX = 0 To bRepr.GetUpperBound(0)
            For iTileY = 0 To bRepr.GetUpperBound(1)
                fillTile(bmp, iTileX, iTileY, iTileWidth, iTileHeight, bRepr(iTileX, iTileY))
            Next
        Next
        Return bmp
    End Function
    ''' <summary>
    ''' Fills given tile with color depending on bState.
    ''' </summary>
    Private Shared Sub fillTile(ByRef bmp As Bitmap, ByVal iTileX As Integer, ByVal iTileY As Integer, ByVal iTileWidth As Integer, ByVal iTileHeight As Integer, ByVal bState As Boolean)
        For iX = iTileX * iTileWidth To iTileX * iTileWidth + iTileWidth - 1
            For iY = iTileY * iTileHeight To iTileY * iTileHeight + iTileHeight - 1
                If bState = True Then
                    bmp.SetPixel(iX, iY, Color.Black)
                Else
                    bmp.SetPixel(iX, iY, Color.White)
                End If
            Next
        Next
    End Sub
End Class
